﻿@model MyBusinessModel
@using System.Security.Claims
@using LAP.Areas.Adviser.Models
@{
    var FMO = (Affiliation)ViewBag.FMO;
    var BD = (Affiliation)ViewBag.BD;
    var RIA = (Affiliation)ViewBag.RIA;
    var role = User.FindFirst(ClaimTypes.Role)?.Value;
    var area = role == Roles.FirmPrincipal ? "firm-principal" : role == Roles.FirmAdmin ? "firm-admin" : "adviser";
}
<form action="adviser/profile/savebusiness" class="form fv-plugins-bootstrap fv-plugins-framework" id="kt_adviserinfo_form" method="post" data-ajax="true" data-ajax-begin="onFormBegin" data-ajax-complete="onFormCompleteWithWizard">
    <div class="d-flex justify-content-between mb-5">
        <div>
            <h4 class="text-dark font-weight-bold mt-2 mb-5 mr-5">Maintain your current financial practice information  here</h4>
        </div>
        <div>
            <button class="btn btn-secondary font-weight-bold px-6 py-2 font-size-h4 btn-sm" id="btn-save-exit">Save & Exit</button>
        </div>
    </div>
    <div class="wizard-content-height">
        <div class="row">
            <div class="col-xl-4">
                <div class="form-group">
                    <label asp-for="FieldMarketingOrganization"></label>
                    <button class="btn btn-icon btn-sm btn-firm-edit float-right @(FMO.Id > 0 ?"":"d-none")" style="margin-top:-5px" data-type="@((int)AffiliationTypeEnum.FieldMarketingOrganization)" data-target="@AffiliationTypeEnum.FieldMarketingOrganization.ToString()" type="button">
                        <i class="far fa-edit text-primary" data-toggle="tooltip" data-original-title="Edit"></i>
                    </button>
                    <select class="form-control form-control-lg select2-control select2" asp-for="FieldMarketingOrganization" data-type="@((int)AffiliationTypeEnum.FieldMarketingOrganization)" data-placeholder="Select or Search" data-text="@FMO.Name" data-id="@FMO.Id" data-guid="@FMO.Guid" data-allow-clear="true">
                        @if (FMO.Id > 0)
                        {
                            <option value="@FMO.Id" selected>@FMO.Name</option>
                        }
                    </select>
                    <span asp-validation-for="FieldMarketingOrganization" class="text-danger"></span>
                </div>
            </div>
            <div class="col-xl-4">
                <div class="form-group">
                    <label asp-for="BrokerDealer"></label>
                    <button class="btn btn-icon btn-sm btn-firm-edit float-right @(BD.Id > 0 ?"":"d-none")" style="margin-top:-5px" data-type="@((int)AffiliationTypeEnum.BrokerDealer)" data-target="@AffiliationTypeEnum.BrokerDealer.ToString()" type="button">
                        <i class="far fa-edit text-primary" data-toggle="tooltip" data-original-title="Edit"></i>
                    </button>
                    <select class="form-control form-control-lg select2-control select2" asp-for="BrokerDealer" data-type="@((int)AffiliationTypeEnum.BrokerDealer)" data-placeholder="Select or Search" data-text="@BD.Name" data-id="@BD.Id" data-guid="@BD.Guid" data-allow-clear="true">
                        @if (BD.Id > 0)
                        {
                            <option value="@BD.Id" selected>@BD.Name</option>
                        }
                    </select>
                    <span asp-validation-for="BrokerDealer" class="text-danger"></span>
                </div>
            </div>
            <div class="col-xl-4">
                <div class="form-group">
                    <label asp-for="RegisteredInvestmentAdvisor"></label>
                    <button class="btn btn-icon btn-sm btn-firm-edit float-right @(RIA.Id > 0 ?"":"d-none")" style="width:20px;margin-top:-5px" data-type="@((int)AffiliationTypeEnum.RegisteredInvestmentAdvisor)" data-target="@AffiliationTypeEnum.RegisteredInvestmentAdvisor.ToString()" type="button">
                        <i class="far fa-edit text-primary" data-toggle="tooltip" data-original-title="Edit"></i>
                    </button>
                    <select class="form-control form-control-lg select2-control select2" asp-for="RegisteredInvestmentAdvisor" data-type="@((int)AffiliationTypeEnum.RegisteredInvestmentAdvisor)" data-placeholder="Select or Search" data-text="@RIA.Name" data-id="@RIA.Id" data-guid="@RIA.Guid" data-allow-clear="true">
                        @if (RIA.Id > 0)
                        {
                            <option value="@RIA.Id" selected>@RIA.Name</option>
                        }
                    </select>
                    <span asp-validation-for="RegisteredInvestmentAdvisor" class="text-danger"></span>
                </div>
            </div>
        </div>
        <div class="form-group">
            <label asp-for="BDDisclosure"></label>
            <textarea class="form-control form-control-lg autosize" asp-for="BDDisclosure"></textarea>
            <span asp-validation-for="BDDisclosure" class="text-danger"></span>
        </div>
        <div class="form-group">
            <label asp-for="RIADisclosure"></label>
            <textarea class="form-control form-control-lg autosize" asp-for="RIADisclosure"></textarea>
            <span asp-validation-for="RIADisclosure" class="text-danger"></span>
            <div class="d-flex flex-row text-info font-italic font-size-lg mt-2">
                <span class="font-weight-bold mr-2">Note:</span>
                <span>Leave blank unless instructed by your Firm</span>
            </div>
        </div>
        <div class="row">
            <div class="col-xl-4">
                <div class="form-group">
                    <label asp-for="CompensationType"></label>
                    <select class="form-control form-control-lg" asp-for="CompensationType" asp-items="Html.GetEnumSelectList<CompensationTypeEnum>()"></select>
                    <span asp-validation-for="CompensationType" class="text-danger"></span>
                </div>
            </div>
        </div>
    </div>
    <partial name="_WizardFooter" />
</form>
<div class="modal" id="affiliationModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true"></div>
<script>
    var addEditAffiliation = function(id, callback) {
        KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
        loadPartialView(`adviser/profile/affiliation?guid=${id}`, "affiliationModal", null, callback);
        setTimeout(function() { KTApp.unblockPage(); }, 1000);
        $("#affiliationModal").modal({ backdrop: 'static' });
    }
    var initFirmSelect2 = function(el) {
        var type = $(el).attr("data-type");
        $(el).select2({
            ajax: {
                url: `adviser/profile/GetAffiliations?type=${type}`,
                data: function(params) {
                    return { term: params.term, page: params.page || 1 };
                },
                processResults: function(data, params) {
                    params.page = params.page || 1;
                    return {
                        results: data.items,
                        pagination: {
                            more: (params.page * 10) < data.totalCount
                        }
                    };
                }
            },
            templateResult: function template(data) {
                if (data.id == 0)
                    return $(`<span class="text-primary">Add new item in the list</span>"`);
                return data.text;
            },
        });
    }
    var showHideDisclosure = function() {
        autosize($('textarea'));
        var Bd = $("#BrokerDealer").val();
        if (Bd > 0)
            $("#BDDisclosure").closest(".form-group").removeClass("d-none");
        else {
            $("#BDDisclosure").val("");
            autosize.update($('textarea'));
            $("#BDDisclosure").closest(".form-group").addClass("d-none");
        }
        var Ria = $("#RegisteredInvestmentAdvisor").val();
        if (Ria > 0)
            $("#RIADisclosure").closest(".form-group").removeClass("d-none");
        else {
            $("#RIADisclosure").val("");
            autosize.update($('textarea'));
            $("#RIADisclosure").closest(".form-group").addClass("d-none");
        }
    }
    showHideDisclosure();
    $(".select2-control").each(function() {
        initFirmSelect2(this);
    });
    $(".select2-control").on('select2:open', function(e) {
        $(".select2-search__field").addClass("capitalize");
    });
    $(".select2-control").on('select2:select', function(e) {
        var currentVal = $(`#${e.target.id}`).attr("data-id");
        currentVal = currentVal > 0 ? currentVal : null;
        var data = e.params.data;
        if (data.id == 0) {
            $(e.target).val(currentVal).trigger("change");
            addEditAffiliation(null, function() {
                var type = $(e.target).attr("data-type");
                setTimeout(function() {
                    $("#Type").val(type).trigger("change");
                    $("#Type").closest(".form-group").addClass("disabled-div");
                    $("#Type").closest(".bootstrap-select.form-control").addClass("disabled");
                    if (type == AffiliationType.RegisteredInvestmentAdvisor)
                        $("#sec-registered").removeClass("d-none");
                }, 0);
            });
        }
        else {
            $(`#${e.target.id}`).attr("data-id", data.id);
            $(`#${e.target.id}`).attr("data-guid", data.guid);
            $(`#${e.target.id}`).attr("data-text", data.text);
            $(`[data-target='${e.target.id}']`).removeClass("d-none");
            showHideDisclosure();
        }
    });
    $(".select2-control").on('select2:clear', function(e) {
        $(`#${e.target.id}`).attr("data-id", "");
        $(`#${e.target.id}`).attr("data-guid", "");
        $(`#${e.target.id}`).attr("data-text", "");
        $(`[data-target='${e.target.id}']`).addClass("d-none");
        showHideDisclosure();
    });
    $("#wizard-main-div").on("click", ".btn-firm-edit", function(e) {
        e.preventDefault()
        var target = $(this).attr("data-target");
        var guid = $(`#${target}`).attr("data-guid");
        addEditAffiliation(guid);
    });
    $("#btn-submit").click(function(e) {
        var FMO = $("#FieldMarketingOrganization").val();
        var BD = $("#BrokerDealer").val();
        var RIA = $("#RegisteredInvestmentAdvisor").val();
        if (!FMO && !BD && !RIA) {
            e.preventDefault();
            _showFormMessage("kt_adviserinfo_form", "danger", "Please select at least one option from FMO/BD/RIA", "fas fa-exclamation-triangle");
        }
    });
</script>